
// rev 07/04/2023
#include "DS18B20_barker.h"
#include "OneWire_barker.h"

extern void PrintChar(unsigned char txData);;

/*
  Envoie un message  tous les capteurs pour recuperer une info lecture
 */
void broadcastConvert() {
  //broadcast that temp conversions should begin, all at once so saves time
  onewireInit();
  onewireWriteByte(0xCC);
  onewireWriteByte(0x44);
  while (1) {
    if (onewireReadBit())  // au moins 1 capteur connect
      break;
  }
}

/*
  retrieve temperatures from sensors
*/
float getTemperature(unsigned char* address) {
  //get temperature from the device with address address
  unsigned char i;
  float temperature;
  unsigned char scratchPad[9] = {0,0,0,0,0,0,0,0,0};
  onewireInit();
  onewireWriteByte(0x55);
  for (i = 0; i < 8; i++)  onewireWriteByte(address[i]);
  onewireWriteByte(0xBE);
  for (i = 0; i < 2; i++)  scratchPad[i] = onewireReadByte();
  onewireInit();
  temperature = ((scratchPad[1] * 256) + scratchPad[0])*0.0625;
  return temperature;
}

int getTemperatureInt(unsigned char* address) {
  //get temperature from the device with address address
  unsigned char i;
  int temperature;
  unsigned char scratchPad[9] = {0,0,0,0,0,0,0,0,0};
  onewireInit();
  onewireWriteByte(0x55);
  for (i = 0; i < 8; i++) onewireWriteByte(address[i]);
  onewireWriteByte(0xBE);
  for (i = 0; i < 2; i++) scratchPad[i] = onewireReadByte();
  onewireInit();
  temperature = ((scratchPad[1] * 256) + scratchPad[0]);
  return temperature;
}

 void Relecture_ID_datas(char *Po)
 {int i;
 CPrint(" OWS ID = ");  
   PrintChar('{');
   for (i = 0; i<8; i++)
  {
  //  sprintf(CRam1,"0x%02X",OWS_address[i]);
        sprintf(CRam1,"0x%02X",Po+i);
    Print(CRam1);
    if(i<7)PrintChar(',');
  }
  PrintChar('}');
  CRLF1();
 }


/*
  Recupere l'adresse et le CRC16 du capteur , et l'affiche sur terminal UART
*/
void printSingleAddress()
{
  unsigned char i;
  unsigned char crc;
  onewireInit();
  //attach one sensor to port 25 and this will print out it's address
  onewireWriteByte(0x33);
  for (i = 0; i<8; i++) OWS_address[i] = onewireReadByte(); 
  if (OWS_address[0]==0x28)  CPrint(" Code Famille : DS18B20\r\n");
  
  CPrint(" OWS ID# = "); 
   PrintChar('{');
   for (i = 0; i<8; i++)
  {
    sprintf(CRam1,"0x%02X",OWS_address[i]);
    Print(CRam1);
    if(i<7)PrintChar(',');
  }
  PrintChar('}');
  CRLF1();
  //check crc
  crc = onewireCRC(OWS_address, 7);
  sprintf(CRam1," CRC = %02X \r\n",crc);
  Print(CRam1);CRLF1(); 
  
}