
#include "Eeprom_PIC.h"
#include "UART1_Functions.h"

extern  unsigned char Eeprom_Donnees[][17];
extern /* Adresses des 3 capteurs de temprature */
extern unsigned char  SENSOR_ADDRESS[3][8];
extern  unsigned char Flag_Eeprom;
extern unsigned char CRam1[];


void DATAEE_WriteByte(uint16_t bAdd, unsigned char bData)
{
    unsigned char GIEBitValue = INTCON0bits.GIE;

    NVMADRH = (unsigned char)((bAdd >> 8) & 0x03);
    NVMADRL = (unsigned char)(bAdd & 0xFF);
    NVMDAT = bData;
    NVMCON1bits.NVMREG = 0;
    NVMCON1bits.WREN = 1;
    INTCON0bits.GIE = 0;     // Disable interrupts
    NVMCON2 = 0x55;
    NVMCON2 = 0xAA;
    NVMCON1bits.WR = 1;
    // Wait for write to complete
    while (NVMCON1bits.WR)
    {
         __asm("NOP");
    }

    NVMCON1bits.WREN = 0;
    INTCON0bits.GIE = GIEBitValue;   // restore interrupt enable
}

unsigned char DATAEE_ReadByte(uint16_t bAdd)
{
    NVMADRH = (unsigned char)((bAdd >> 8) & 0x03);
    NVMADRL = (unsigned char)(bAdd & 0xFF);
    NVMCON1bits.NVMREG = 0;
    NVMCON1bits.RD = 1;
    __asm("NOP");  // NOPs may be required for latency at high frequencies
    __asm("NOP");

    return (NVMDAT);
}

void Relecture_Eeprom(char Visu)
{ // Visu seulement !
    static unsigned char cc;
    static int i,j,k;
    i=0; j=0;k=0;
    cc= DATAEE_ReadByte(0);
    Flag_Eeprom= cc;
    __delay_ms(25);
    if (Visu==1)
     {
        CPrint(" Relecture datas eeprom : \r\n");
        CPrint(" Flag @ 0x0000 =");
        PrintChar(cc/10+48);  PrintChar(cc%10+48); CRLF1();
     }
     for (i=0;i<3;i++)
     {
          if (Visu==1)
          {   
           CPrint(" Code Sonde #");PrintChar(i+48);  ;PrintChar(':'); 
          }
          k=(i*16)+0x10 ;
          if (Visu==1)
          {
            // utoa(CRam1,k,10);
             sprintf(CRam1," 0x%04X  ",k);
             Print(CRam1); 
             PrintChar(TAB);
          }
          for (j=0;j<8;j++)
          {
              cc= DATAEE_ReadByte(k+j); __delay_ms(25);
              Eeprom_Donnees[i][j]=cc;
             sprintf(CRam1,"0x%02X,",cc );	// en ascii	   
             Print(CRam1);
          }
           Eeprom_Donnees[i][j]=0;    //string terminator
          if(Visu==1)
          {
           //  PrintChar(TAB);
             //Print( Eeprom_Donnees[i]);
           //  sprintf(CRam1,"0x%02X",Eeprom_Donnees[i]);	// en ascii	   
           //  Print(CRam1);
             CRLF1();
           }
     }
     if(Visu==1)  CRLF1();
  }

//void Sauve_Parametres_en_Eeprom(unsigned char *ici)  
void Sauve_Parametres_en_Eeprom()  
{    static unsigned char cc;
    static int i,j,k;
    i=0; j=0; k=0;
    GIEH=0;
    //Flag_Eeprom=99;
    CPrint("\r\n Sauve ID# sondes DS18B20 \r\n");
    CPrint(" Flag Eeprom @0x0000 = ");
    DATAEE_WriteByte(0,Flag_Eeprom); __delay_ms(25);
    PrintChar((Flag_Eeprom/10) +48);    PrintChar((Flag_Eeprom%10) +48);CRLF1();
  
    for (i=0;i<3;i++)
      {  CPrint(" Sonde ID#");PrintChar(i+48); 
         k=(i*16)+ 0x0010;
         sprintf(CRam1,"@ 0x%04X  -> ",k);
         Print(CRam1); 
         for (j=0;j<8;j++)
         {
          // cc=*(ici+k+j);  
          cc= SENSOR_ADDRESS[i][j];  
          DATAEE_WriteByte(k+j,cc); __delay_ms(25);
          sprintf(CRam1,"0x%02X,",cc);	// en ascii	   
          Print(CRam1);
          
         }
         CRLF1();
       }
     CRLF1();
     GIEH=1;

 }

unsigned char  Restitue_Parametres_en_Eeprom(int Element)
{   // Eeeprom -> Tables de Travail
   static int i,j,k;
   static unsigned char cx;
   j=0;i=0;k=0;
      CPrint(" Read flag @0x00 = ");
      Flag_Eeprom=DATAEE_ReadByte(0);__delay_ms(50);
      sprintf(CRam1,"0x%02X", Flag_Eeprom);
      Print(CRam1);
    // utoa(CRam1, Flag_Eeprom,10);
   //   My_Print(CRam1);CRLF1();
     CPrint(" Restitue sonde ID#");
     PrintChar(Element+48);CRLF1();
     if ( (Element>3) || (Element<1))  return 0; 
     k= (Element<<4) + 0x0010; // Element*16 +10
     sprintf(CRam1,"@ 0x%04X ", k);
     Print(CRam1);
     for (j=0;j<8;j++)
     {
        cx= DATAEE_ReadByte(k+j); __delay_ms(25);
       SENSOR_ADDRESS[Element-1][j]=cx;
       sprintf(CRam1,"0x%02X,",cx);
       Print(CRam1);
      }
      SENSOR_ADDRESS[Element-1][j]=0;  //string terminator
      CRLF1();
     //last check :
      Print((char *)&SENSOR_ADDRESS[Element-1][0]);
      CRLF1();
 }
     